
#include <avr/io.h>
#define F_CPU 20000000
#include <util/delay.h>

#define TRUE 1
#define FALSE 0

#define SWITCH PA2

#define LED_R PA3
#define LED_G PA7
#define LED_B PB2

uint8_t mode = 0;

int turn_off(uint8_t led_color)
{
   if (led_color == LED_B)
      PORTB |= _BV(led_color); // Off
   else
      PORTA |= _BV(led_color); // Off   
}

int blink(uint8_t led_color)
{

   if (led_color == LED_B) {
      PORTB &= ~(_BV(led_color)); // On
      _delay_ms(500);
      turn_off(led_color);
      _delay_ms(500);
   }
   else {
      PORTA &= ~(_BV(led_color)); // On
      _delay_ms(500);
      turn_off(led_color);
      _delay_ms(500);
   }
}

int main()
{

   //SETUP

   DDRA = _BV(LED_R) | _BV(LED_G); // Define PA3 as output (LED Red); // Define PA7 as output (LED Green); 
   DDRB = _BV(LED_B); // Define PB2 as output (LED Blue);

   PORTA = _BV(SWITCH); //Initate pull-resistor for input


   turn_off(LED_R);
   turn_off(LED_G);
   turn_off(LED_B);

   //LOOP
   while (TRUE)
   {
      if (!(PINA & _BV(SWITCH))) //Button is pressed
      {
         ++mode;
         if (mode==5) mode=0;
         _delay_ms(10);
         while (!(PINA & _BV(SWITCH))) // if switch is still pressed, wait
         _delay_ms(10);
      }

      switch (mode) {      
         case 0:
            blink(LED_R);
            blink(LED_G);
            blink(LED_B);
            break;
         case 1:
            blink(LED_R);
            turn_off(LED_G);
            turn_off(LED_B);
            break;
         case 2:
            turn_off(LED_R);
            blink(LED_G);
            turn_off(LED_B);
            break;
         case 3:
            turn_off(LED_R);
            turn_off(LED_G);
            blink(LED_B);
            break;
         case 4:	   
            turn_off(LED_R);            
            turn_off(LED_G);            
            turn_off(LED_B);            
            break;
 
      }
   }
}
